if spd==nil then spd={} end

-- Configurations
spd.max=148 -- Setting it too much may results with annoying glitches.
-- Functions

function totable(t,match)
local cmd = {}
if not match then match = "[^%s]+" end
for word in string.gmatch(t, match) do
table.insert(cmd, word)
end 
return cmd 
end

function init(a,b)
local array = {}
for i = 1, a do
array[i] = b
end
return array
end

spd.value=init(32,0)
spd.lx=init(32,0)
spd.ly=init(32,0)
spd.ax=init(32,0)
spd.ay=init(32,0)


function spd.set(i,v)
spd.value[i]=v
end

function spd.console(txt)
	t=string.lower(txt)
	str_=totable(t)
	str1_=tostring(str_[1])
	str2_=tonumber(str_[2])
	str3_=tonumber(str_[3])
	str4_=tonumber(str_[4])
	if str1_ =="speedmod" then
		if player(str2_,"exists") then
			if (str3_ >100) then
				if str3_ <=spd.max then
					spd.set(str2_,(str3_-100))
				end
			end
		end
	elseif str1_ =="setpos" then
		spd.lx[str2_]=str3_
		spd.ly[str2_]=str4_
	end
end
addhook("parse","spd.console")
function spd.spawn(id)
	spd.lx[id]=player(id,"x")
	spd.ly[id]=player(id,"y")
end
addhook("spawn","spd.spawn")
function spd.move(id,x,y,w)
	spd.ax[id]=spd.lx[id]
	spd.ay[id]=spd.ly[id]
	spd.lx[id]=x
	spd.ly[id]=y
	if player(id,"speedmod")==100 then
		angle=-(math.deg(math.atan2(spd.lx[id]-spd.ax[id],spd.ly[id]-spd.ay[id])))
		spd.ax[id]=spd.lx[id]
		spd.ay[id]=spd.ly[id]
		spd.lx[id]=x
		spd.ly[id]=y
		inradian=math.rad(angle)
		targetx,targety=-math.sin(inradian)*(spd.value[id]),math.cos(inradian)*(spd.value[id])
		if w then parse("setpos "..id.." "..player(id,"x")+(targetx/2).." "..player(id,"y")+(targety/2)) else parse("setpos "..id.." "..player(id,"x")+targetx.." "..player(id,"y")+targety) end
		spd.ax[id]=spd.lx[id]
		spd.ay[id]=spd.ly[id]
		spd.lx[id]=x
		spd.ly[id]=y
	end
	if tile(player(id,"tilex"),player(id,"tiley"),"walkable") then else
		parse("setpos "..id.." "..spd.lx[id].." "..spd.ly[id])
	end
	spd.ax[id]=spd.lx[id]
	spd.ay[id]=spd.ly[id]
	spd.lx[id]=x
	spd.ly[id]=y

end
addhook("move","spd.move")
function spd.sec()
	for id=1,32 do
		if player(id,"exists") then
			spd.ax[id],spd.ay[id]=spd.lx[id],spd.ly[id]
		end
	end
end
--addhook("second","spd.sec")